"airefraction" <-
function(sonardata, Flags, spacing){

# DESCRIPTION

# Find what are the times at which the specific cummulative intensity fractions
# of the first echo is reached

# INPUT

# sonardata			The data matrix containing the sonar return intensity values
# spacing			The new timelaps at which the intensities values were 
#					resampled
# Flags				A Vector of marker describing how many echoes are within one
#					return

	necho<-nrow(sonardata)
	frac<-matrix(NA, necho, 15)
	use<-which(Flags>=1)
	for (i in use){
		ffrac<-(c(1:15)/16)*sum(sonardata[i,])
		k<-1
		for(j in 1:length(ffrac)){
			frac[i,j]<-min(which(cumsum(sonardata[i,])>=ffrac[j]),na.rm=TRUE)*
				spacing
		}
	}
	colnames(frac)<-c("F1.16", "F2.16", "F3.16", "F4.16", "F5.16", "F6.16",
		"F7.16", "F8.16", "F9.16", "F10.16", "F11.16", "F12.16", "F13.16", 
		"F14.16", "F15.16")
	return(frac)
}

