"altitude.filter" <-
function(x, alt, trigger=0.6, width=6, height=6, 
	plot.show=TRUE, plot.save=NULL, quiet=TRUE){

# DESCRIPTION

# Produce a plot, or and save it. The plot described the altitude variations 
# over time 

# INPUT

# x				is a time sequence
# alt 			is the altitudes values
# trigger		is in meters. It is the altitude difference or jump relative to 
#				the previous and after echo that is required to considered the 
#				point wrong...
# width			Plot width in inches
# height		Plot height in inches
# plot.show	If TRUE, it makes a plot during computation
# plot.save		If TRUE, it save the plot


	avant<-abs(alt[2:(length(alt)-1)]-alt[1:(length(alt)-2)])
	apres<-abs(alt[2:(length(alt)-1)]-alt[3:(length(alt))])
	rem<-which(avant>=trigger & apres>=trigger)+1
	if(length(plot.save)!=0){
		nom<-"filter.alt"
		path<-paste(plot.save, "/", nom, ".pdf", sep="")
		pdf(file = path, onefile = TRUE, width=width, height=height, 
			family="Helvetica", encoding="MacRoman.enc", pagecentre=TRUE)
		plot(x, alt[], "l", main="Original and filtered altitude values");
		if(length(rem)!=0){
			lines(x[-rem], alt[-(rem)], col="red")
		}else{
			lines(x[], alt[], col="red")
			cat("\tThere is no erroneous altitude value found\n")
		}
		dev.off()
	}else{}
	if(plot.show==TRUE){
		dev.size(w=width, h=height)
		plot(x, alt, main="Original and filtered altitude values");
		if(length(rem)!=0){
			lines(x[-rem], alt[-(rem)], col="red")
		}else{
			lines(x[], alt[], col="red")
			cat("There is no erroneous altitude value found\n")
		}
	}else{}
	if(quiet==FALSE)
		cat("\nLes chos supprims ayant de mauvaise valeurs d'altitude sont",
			"les suivantes", rem, "\n")
	if(length(rem)!=0){
		x<-x[-rem]
		alt<-alt[-rem]
	}else{}
	return(list(rem=rem, alt=alt))
}

