"bathy.krig"<-function(nav, width=6, height=6, max.dist=50, name="Bathy", gridsize=50, cov.model="cubic", step=0.2, quiet=FALSE, plot.save=NULL, xlim=NULL, ylim=NULL, plotquartz=TRUE, main="Bathymetry Map",fix.nugget=FALSE){
	#This graph allows us to produce a grayscale bathymetric map with contours
	#nav=cbind(psx2$y,psy2$y,newalt[sel])
	#nav=cbind(psx2$y,psy2$y,footprint.depth[sel])
	#nav=s$nav1;width=6;height=6;max.dist=50;gridsize=50;cov.model="cubic";step=0.2
	if(length(plot.save)!=0){
		path<-paste(plot.save, name, ".pdf", sep="")
		cat("The graphic will be recorded, but not displayed")
		pdf(file = path, onefile = TRUE, width=width, height=height,  
			family="Helvetica", encoding="MacRoman.enc", pagecentre=TRUE)
	}else{
		quartz(w=width, h=height)
	}
	navgeo=as.geodata(nav, coords.col = c(1,2), data.col = 3)
	mrk<-0
	ok<-0
	l=50
	
	while(mrk==0){
		uvec=seq(0, max.dist, l = l)
		vario1=variog(navgeo, max.dist=max.dist, uvec = uvec)
		#cubic is curverd #circular is straight
		para = variofit(vario1, ini = expand.grid(seq(0, max(vario1$v),
			l=gridsize), seq(0, max(vario1$u), l=gridsize)), 	
			cov.model=cov.model, fix.nugget = fix.nugget)
		plot(vario1);lines(para)
		if(quiet!=TRUE){
			cat("Are you satisfied with the model: Yes=1 or No=0")
			ok<-scan("", nlines=1, quiet=TRUE)
			if(ok==1){
				mrk<-1
			}else{
				cat("The previous gridsize was", gridsize, 
					"please enter the same or a new value:\n")
				tmp0<-scan("", nlines=1, quiet=TRUE)
				gridsize<-tmp0
				
				cat("The previous covariance model was", cov.model, 
					"please enter the same or a new model:\n")
				tmp0<-scan("", what="character", nlines=1, quiet=TRUE)
				while(tmp0!="matern" & tmp0!="exponential" & tmp0!="gaussian" &
					tmp0!="spherical" & tmp0!="circular" & tmp0!="cubic" &
					tmp0!="wave" & tmp0!="power" & tmp0!="powered.exponential" &
					tmp0!="cauchy" & tmp0!="gneiting" & tmp0!="gneiting.matern" 
					& tmp0!="pure.nugget"){
					if(tmp0=="matern" & tmp0=="exponential" & tmp0=="gaussian" & 
						tmp0=="spherical" & tmp0=="circular" & tmp0=="cubic" & 
						tmp0=="wave" & tmp0=="power" & 
						tmp0=="powered.exponential" & tmp0=="cauchy" & 
						tmp0=="gneiting" & tmp0=="gneiting.matern" & 
						tmp0=="pure.nugget"){
						cov.model=tmp0
					}else{
						cat("You have typed an unknown model\n")
						cat("The previous gridsize was", cov.model, 
							"please enter the same or a new model:\n")
						tmp0<-scan("", what="character", nlines=1, quiet=TRUE)
					}
				}
				
				cat("The previous max distance used was", max.dist, 
					"please enter the same or a new value:\n")
				tmp0<-scan("", nlines=1, quiet=TRUE)
				max.dist<-tmp0
				
				cat("The previous number of bin used was", l, 
					"please enter the same or a new value:\n")
				tmp0<-scan("", nlines=1, quiet=TRUE)
				l<-tmp0
				
				cat("The previous fix.nugget was", fix.nugget, 
					"please enter the same or a new value:\n")
				tmp0<-as.logical(scan("", what="raw", nlines=1, quiet=TRUE))
				fix.nugget<-tmp0
			}
		}else{
			mrk<-1
		}
	}
	tmp1<-range(navgeo$coords[,1])
	tmp2<-range(navgeo$coords[,2])
	tmp0<-range(nav[,3])
	#This is to constructe a grid where the kriging will start. 
	##The more points there are on the grid, the finnest the kriging will be. A grid very fine (with a lot of points) will take longer to construct.	
	pred.grid = expand.grid(seq(tmp1[1], tmp1[2], by=step),  seq(tmp2[1],
		tmp2[2], by=step))
	##This is to construct the kriging map from the altitude data
	kc = krige.conv(navgeo, loc = pred.grid, 
		krige = krige.control(obj.m = para))
	##This is to present the kriging map as an image
	tru<-(trunc((tmp0[2]-tmp0[1])/0.5))
	se<-gray(seq(1, 0.4, length=tru))
	image(kc, loc = pred.grid, col=gray(seq(1, 0.4, length=11)), xlab="Label",
		ylab="Coord Y", main="Bathymetry Map")
	contour(kc, loc = pred.grid, nlevel=11, xlab="Label", ylab="Coord Y", 
		add=TRUE)
#	legend.krige(x.leg = c(1.05, 1.1), y.leg = c(0, 1),kc$pred, vert = FALSE, off = 1.5, cex = 1.5)

	if(length(plot.save)!=0)
		dev.off()

}