"check.file" <-
function(path=NA, quiet=FALSE, type=NA){
# DEFINITION

# Look if the file or files exist and if not ask the user to select the missing
# file

# INPUT

# path 			The object or vector in which the file paths are stored.
#				If an erroneous path is given even if quiet=TRUE, a brower 
#				will appear.
# quiet			If set to TRUE, the user will not be asked to find the missing 
#				file is the original path is set to NULL
# type			A serie of character that must be found in the file name

# OUTPUT

# path			Output the corrected paths
	tmp<-path
	for(i in 1:length(path)){
		tmp44<-0
		#### As long as a matching file is not selected
		while(tmp44!=1){
			#### It must concur with a speciic name type 
			if(!is.na(type)){
				#### There is a path	
				if(!is.na(tmp[i])){
					#### The file path is wrong
					if(length(grep(type, tmp[i]))!=1){
						cat("It must be a '", type, "' type file\n", sep="")
						flush.console()
						cat("Please select the file that should be in", 
							deparse(substitute(path[i])),"\n")
						flush.console()
						tmp[i]<-file.choose()
					#### The file path concurs with the type
					}else{
						tmp0<-file.access(tmp[i])
						#### Incorrect path
						if(tmp0==-1){
							cat("There is no file at:\n",tmp[i], 
								"\nPlease select the file that should be in ",
								deparse(substitute(path[i])),"\n", sep="")
							flush.console()
							tmp[i]<-file.choose()
						#### Path is OK and the file was found
						}else{
							tmp44<-1
						}
					}
				#### There is no path
				}else{
					if(quiet==FALSE){
						cat("Please select the file that should be in", 
							deparse(substitute(path[i])),"\n")
						flush.console()
						tmp[i]<-file.choose()
						cat("\t",basename(tmp[i]),"\n")
					}else{
						tmp44<-1
					}
				}
			#### It does not have to concur with a speciic name type 
			}else{
				#### There is a path	
				if(!is.na(tmp[i])){
					tmp0<-file.access(tmp[i])
					#### Incorrect path
					if(tmp0==-1){
						cat("There is no file at:\n",tmp[i], 
							"\nPlease select the file that should be in ",
							deparse(substitute(path[i])),"\n", sep="")
						flush.console()
						tmp[i]<-file.choose()
					   #### Path is OK and the file was found
					}else{
						tmp44<-1
					}
				#### There is no path
				}else{
					if(quiet==FALSE){
						cat("Please select the file that should be in", 
							deparse(substitute(path[i])), "\n")
						flush.console()
						tmp[i]<-file.choose()
						cat("\t",basename(tmp[i]),"\n")
					}else{
						tmp44<-1
					}
				}
			}
		}
	}
	return(as.character(tmp))
}

