"consecutive" <-
function(data,nb=5,thresh=NULL,direction="start",
			method = c("bellow", "over")){
			
# DESCRIPTION

# Find in a vector the starting or ending point of a serie of consecutive values
# that differs at least by the threshold value


# INPUT

# data			A vector of intensity to scan for 
# nb			Width or the number of consecutive values that should be either
#				increasing or decreasing by at least the threshold value
# thresh		the threshold value
# direction		if "start" or " end" defines which intensity number is return, the one at the end or startpart of the consecutive sequence of inhthe start of each sequence is returnes
# method
# OUTPUT#direction = increase or decrease			
#Data is one echo section
#nb is the number consecutive values
#thresh is threshold to consider is a difference is to be kept
#method defines is the values bellow or over the threshold are to be kept in the search
	if(is.null(thresh))
		stop("Seuil is a required value\n")
	tmp<-data[2:length(data)]-data[1:(length(data)-1)]
	if(method!="bellow" & method!="over")
		stop("Wrong method type in consecutive function\n")
	if(method=="bellow"){
	 	tmp[tmp>thresh]=NA
		tmp[tmp<=thresh]=1
   	}else{
   		tmp[tmp<thresh]=NA
		tmp[tmp>=thresh]=1
	}
	nk=nb-1
	for(i in 1:(nb-1)){
		tmp0<-tmp[2:length(tmp)]*tmp[1:(length(tmp)-1)]
		if(sum(tmp0,na.rm=TRUE)==0){
			nk=i
			break
		}
		else
			tmp<-tmp0
	}
	tmp4<-which(tmp==1)
	if(direction=="end")
		tmp4<-tmp4+nk
	return(tmp4)
}

