"correction" <-
function( sonardata, oldalt, newalt=NULL, depth.ref=1, abs.rate.ori=0, logf.ori=1, start.gain.ori=1, abs.rate.cor=0, logf.cor=1, start.gain.cor=1, abs.rate.ref=0, logf.ref=1, start.gain.ref=1 ){ 
	
# DESCRIPTION
	
# Because the data were previously corrected by Imagenex. 
# These calculation had to be undone.
# Based on the formula they used, we applied the corrections to our 
# sonar survey in order to obtain the original signal intensity strength
# Through trial and error the best ar values, which stands for absorption rate 
# was found through careful observation of the graph produced 
# by graph.depthnorm funtion 

# NOTE 

# The values used here are specifically designed to work for our study only.
# Thus the idea is to return a intensity values that have been well corrected 
# for the absorption rate based on our altitude estimation. 
# Corrections for spherical spreading and temporal strechting is done later.
	if(is.null(newalt)) newalt<-oldalt
	#### Absorption rate set in Imagenex acquisition soft.
#	abs.rate.ori<-0.2
#	logf.ori<-40
#	start.gain.ori<-6
	#### ar that it should have been
#	abs.rate.cor<--0.2
#	logf.cor<-40
#	start.gain.cor<-6	
	#### Reference values
#	abs.rate.ref<--0.1
#	logf.ref<-0
#	start.gain.ref<-6
	
	ori<-sonardata
	
	for(j in 1:nrow(sonardata)){
		#### Remove the imagenex corrections
		Vin <- sonardata[j,] / (10^((start.gain.ori + logf.ori * 
		log10(oldalt[j] / depth.ref) + abs.rate.ori * oldalt[j]) / 20))
		#### Create a file with values that are not corrected
		ori[j,] <- Vin
		#### Based on our altitude value, we correct only for the absorption 
		#### rate and start gain
				
		sonardata[j,] <- Vin * (10^((start.gain.ref + logf.ref * log10(newalt[j] 
		/ depth.ref) + abs.rate.ref * newalt[j]) / 20))
	} 
	return(list(sonardata=sonardata, ori=ori))
}

