"data.screening" <-
function(VIS, timespm){
	
# DESCRIPTION

# Finds which echos are described by the VIS
# Finds which VIS cannot be described by any echoes
# Truncates avery times to the second

# INPUT

# VIS 			The response variable matrix.  It must have rownames = to the 
#				time of acquisition in seconds past midnight
# timespm 		A vector with all the times at which we acquired a sonar ping

	u<-0
	w<-0
	vistime<-trunc(as.numeric(rownames(VIS)))
	timespm<-trunc(as.numeric(timespm))
	r1<-range(timespm)
	r2<-range(vistime)
	if(r2[1]>r1[2] | r2[2]<r1[1])
		stop("The times describing the VIS file does not match those of the recorded echoes\n")
	tmp<-1:length(vistime)
	for(i in tmp){
		t<-which(timespm==vistime[i])
		if(length(t)==0){
			if(w[1]==0 ){
				w<-i
			}else{
				w<-c(w, i)
			}
		}else{
			if(u[1]==0){
				u<-t
			}else{
				u<-c(u, t)
			}
		}
	}
	if(length(w)==1 & w[1]==0)
		w=-tmp
	u<-as.numeric(levels(as.factor(sort(u))))
	return(list(rem.vis=w, keep=u))
}

