"depth.filter" <-
function(x=NULL,depth,varlimit=10,width=6,height=6,plot.show=TRUE,
main="Original and filtered depth values",plot.save=NULL,quiet=TRUE){
#x is a time sequence
#alt is the altitudes values
#trigger= in meters, the altitude difference or jump relative to the previous and after echo that is required to considered the point wrong... 
	len<-length(depth)
	avant<-abs(depth[2:(len-1)]-depth[1:(len-2)])
	apres<-abs(depth[2:(len-1)]-depth[3:(len)])
	#Si l'on retrouve de chaque cot d'une altitude un ecart de plus de 10 m nous le supprimons
	rem<-which(avant>=varlimit & apres>=varlimit)+1
	if(is.null(x))
		x<-c(1:len)
	
	if(length(plot.save)!=0){
		nom<-"filter.depth"
		path<-paste(plot.save,"/",nom,".eps",sep="")
		postscript(file = path,paper="special", onefile = TRUE,width=width,height=height, family="Helvetica", encoding="MacRoman.enc",pagecentre=TRUE)
		plot(x,depth,"l",main=main);
		lines(x[-rem],depth[-rem],"l",col="red")
		dev.off()
	}else{}
	if(plot.show==TRUE){
		dev.size(w=width,h=height)
		plot(x,depth,"l",main=main);
		lines(x[-rem],depth[-rem],"l",col="red")
	}else{}
	if(length(rem)!=0)
		depth<-depth[-rem]
	if(quiet==FALSE)
		cat("Les chos supprims ayant de mauvaise valeurs de profondeur sont les suivantes",rem) 
	return(list(rem=rem,depth=depth))
}

