"echoextract" <-
function(sonardata, debut, fin, Flags){

# DESCRIPTION

# We extract the first echo out of the data matrix containing the sonar return 
# intensity values

# INPUT

# sonardata		The data matrix containing the sonar return intensity values
# debut			The start position at which we shall begin the extracting
# fin			The end position at which we shall stop the extracting
# Flags			A Vector of marker describing how many echoes are within one
#				return

	tmp<-(max(fin-debut, na.rm=TRUE))+1
	necho<-nrow(sonardata)
	normecho1<-matrix(0, necho, tmp)
	use<-which(Flags>=1)
	for(i in use){
		normecho1[i,1:(fin[i]-debut[i]+1)]<-sonardata[i,debut[i]:fin[i]]
	}
	return(normecho1)
}

