"echostartend" <-
function(lisse, Vmx.sE=NULL, Vmn.sE=NULL, max.jump=NULL, 
	thresh.high=0.05, thresh.low=0.01, nb=5, debut=TRUE, fin=TRUE){

# DESCRIPTION

# This function specialize in finding the area of consecutive increasing or
# decreasing intensity values

# INPUT

# lisse				The smoothe sonar return matrix
# Vmx.sE=NULL		A vector of the sonar return maximum value
# Vmn.sE=NULL		A vector of the sonar return minimum value
# max.jump=NULL		This value is definite in fonction or all the sonar value
#					It corresponds to the amount of increase required between 
#					each intensity value in the serie we are looking for.
# thresh.high=0.05	The intensity serie must be higher this value
# thresh.low=0.01	Once the serie localised we are looking for a value that is 
#					bellow this lower bondary
# nb=5				The number of consecutive intensity we are looking at			
# debut=TRUE		The beginning of the sonar return section we are 
#					investigating
# fin=TRUE			The end of the sonar return section we are investigating

	#### Consecutive jumps
	nr<-nrow(lisse)
	nc<-ncol(lisse)
	Debut.E<-rep(NA, nr)
	Fin.E<-rep(NA, nr)
	if(is.null(Vmx.sE) | is.null(Vmn.sE)){
		Vmx.sE<-rep(NA, nr)
		Vmn.sE<-rep(NA, nr)
		tmp<-apply(lisse, 1,function(x) any(!is.na(x)))
		Vmx.sE[tmp]<-apply(lisse[tmp,], 1, function(x)  max(x,na.rm=TRUE))
		Vmn.sE[tmp]<-apply(lisse[tmp,], 1, function(x)  min(x,na.rm=TRUE))
	}

	Diff<-Vmx.sE-Vmn.sE
	a1<-max.jump
	a2<--max.jump
	seuil<-Vmn.sE+Diff*thresh.high;
	seuil<-Vmn.sE+Diff;
	minim<-Vmn.sE+Diff*thresh.low
	
	for(j in which(!is.na(Vmx.sE))){
		#### Find the intensity value that does the jump
		if(debut==TRUE){
			#### Find those who are consecutive
			found<-consecutive(lisse[j,], nb=nb, thresh=a1, 
				direction="increase", method="over")
			if(length(found)!=0){
				tmp1<-which(lisse[j,found]<=seuil[j] & lisse[j,found]>=minim[j])
 				if(length(tmp1)!=0){
 					Debut.E[j]<-found[min(tmp1)]
				}else{}
			}else{}		
		}else{}
		#### Looking but for a negative slope
		if(fin==TRUE){
			#### Find those who are consecutive
			found<-consecutive(lisse[j,], nb=nb, thresh=a2, 
				direction="decrease", method="bellow")
			if(length(found)!=0){
				tmp1<-which(lisse[j,found]<=seuil[j] & lisse[j,found]>=minim[j])
 				if(length(tmp1)!=0){
					Fin.E[j]<-found[max(tmp1)]
				}else{}
			}else{}
		}else{}
	}
	return(list(Debut.E=Debut.E, Fin.E=Fin.E, seuil=seuil))
}

