"graph.depthnorm" <-
function(datum, debut1=NA, fin1=NA, debut2=NA, fin2=NA, 
	save.plot=FALSE, width=9, height=7, path=NULL, a=NULL, b=NULL, palet=1, indice=NULL, title="Acoustic returns profile", timelaps=13.333/1000000) {
	
# DESCRIPTION

# INPUT


	#### a doit-tre le dbut d'un transect
	#### J'ai utilis 450 et 1098 pour a et b (alt)
	#### J'ai utilis 478 et 1104 pour a et b (alt)

	library(datasets)
	# warnings()
	# options(warn=1)
	if(is.null(a))
		a<-1
	if(is.null(b))
		b<-nrow(datum)
	if(is.null(indice))
		indice<-as.factor(rep(1, nrow(datum)))
	else
		indice<-as.factor(indice)
	
#### Indice must ba chronological	
	borne<-NA
	for(i in levels(indice[a:b])){ 
		if(is.na(borne))
			borne<-min(which(indice[a:b]==i))
		else
			borne<-c(borne, min(which(indice[a:b]==i)))
	}
	# nom=paste("~/.../", nom, ".pdf", sep="")
	# 	x11(display=":0", width=14, height=12)

	sep=100

	# borne<-bornealt[which(bornealt>a & bornealt+1<b)]
	for(i in 1:length(borne)){
		if(i==1 & i==length(borne)){
			place<-seq(a, b, by=sep)
			valeur<-seq(1, b-a+1, by=sep)
		}else{
			if(i==1){
			}else{
				if(i==2){
					place<-seq(a, borne[i]-1, by=sep)
					valeur<-seq(1, borne[i]-a, by=sep)
				}else{
					place<-c(place, seq(borne[i-1], borne[i]-1, by=sep))
					valeur<-c(valeur, seq(1, (borne[i]-borne[i-1]), by=sep))
				}
				if(i==length(borne)){
					place<-c(place, seq(borne[i], b, by=sep))
					valeur<-c(valeur, seq(1, (b-borne[i]+1), by=sep))
				}else{}
			}
		}
	}
	place=place-a+1
	
	# pdf(file=nom, onefile=F, encoding="PDFDoc.enc", family="Helvetica", 
	# 	paper="special", width=7, height=6)
	# nom=paste("~/.../", nom, "2.eps", sep="")

	if(save.plot==TRUE){
		if(is.null(path)){
			cat("Type a file name describing this plot: ex.: toto", "\n")
			nom<-scan(file="", what="character", quiet=TRUE, nline=1)
			cat("Do you want to save '", nom, 
				".pdf' in the working directory: YES='Y' or NO='N'", "\n", 
				sep="")
			tmp<-scan(file="", what="character", quiet=TRUE, nline=1)
			if(tmp!="Y"){
				cat("Type the directory path you require ~/.../:", "\n")
				tmp1<-scan(file="", what="character", quiet=TRUE, nline=1)
				path<-paste(tmp1, nom, ".pdf", sep="")
			}else{
				path<-paste(getwd(), "/", nom, ".pdf", sep="")
			}
		}else{}
		pdf(file = path, onefile = TRUE, width=width, height=width, 
		family="Helvetica", pagecentre=TRUE)
	}else{
		dev.size(w=width, h=height)
	}
	
	ori<-datum[a:b,]/max(datum[a:b,], na.rm=TRUE)
	
	#### 	255 	=	white
	### 	0 		= 	noir
	if(palet==1){
		br=((seq(0, 1, le=257)^2)^2)*max(ori, na.rm=TRUE)
		mescouleurs<-gray(seq(255, 0, len=256)/255)
	}else{
		br=((seq(0, 1, le=257)^(1.5)))*max(ori, na.rm=TRUE)
		mescouleurs<-gray(seq(250, 0, len=256)/255)
	}
#	nf <- layout(matrix(c(1, 1, 2, 2), 2, 2, byrow=TRUE), respect=F)
	par(omi=c(0.5, 0.5, 0.5, 0.5), fg="black", col.axis="black" , cex.axis=1.25)

#### SCREEN(1)
	par(mai=c(0.4, 0.4, 0.4, 0.4))
	donnees<-ori
	necho<-nrow(donnees)
	lecho<-ncol(donnees)
	ii<-timelaps*1000
	x<-seq(1:necho);
	y<-seq(0:lecho-1)*ii;
	
	image(x, y, donnees[,1:lecho], breaks=br, col=mescouleurs, yaxt="n", 
		xaxt="n", xlab="", ylab="", fg="black", col.axis="black") 
	
	axis(1, place, valeur, col.axis = "black")

	titrex<-paste("Number of recorded backscatter signals")
	#### titrey<-substitute("Acquisition time in "*mu*"sec.")
	titrey<-substitute("Acquisition time in millisec.")
	mtext("Number of recorded backscatter signals", line= 3, side=1, cex=1.5)  
	mtext("Acquisition time in millisec.", line=3, side=2, cex=1.5)
	mtext("Altitude in meters", line=3, side=4, cex=1.5)
	mtext(title, line=2, side=3, cex=2)
#"
	lab<-seq(0, floor((lecho)*ii), by=5)
	at<-lab
	axis(2, at=at, lab=lab, col.axis = "black")
	wh<-which(valeur==1)
	for(i in 1:length(wh)){
		if(i !=length(wh)){
			xx<-seq(place[wh[i]], (place[wh[i+1]]-1), by=1)
			yd1<-debut1[xx+a-1]*ii;yf1<-fin1[xx+a-1]*ii;
			yd2<-debut2[xx+a-1]*ii;yf2<-fin2[xx+a-1]*ii;		
			lines(xx, yd1, col="white", lwd=1);lines(xx, yf1, col="white", 
				lwd=1);
			lines(xx, yd2, col="white", lwd=1);lines(xx, yf2, col="white", 
			    lwd=1);
		}else{
			xx<-seq(place[wh[i]], (b-a+1), by=1)
			yd1<-debut1[xx+a-1]*ii;yf1<-fin1[xx+a-1]*ii;
		    yd2<-debut2[xx+a-1]*ii;yf2<-fin2[xx+a-1]*ii;
			lines(xx, yd1, col="white", lwd=1);lines(xx, yf1, col="white", 
				lwd=1);
			lines(xx, yd2, col="white", lwd=1);lines(xx, yf2, col="white", 
				lwd=1);
		}
	}
	lab<-seq(0, floor((lecho)*ii/1000*1500/2), by=1)
	at<-lab*2/1500*1000
	axis(4, at=at, labels=lab, col.axis="black")
	# par(fg="black")
	box()
#### Graphic's borders
		if(save.plot==TRUE)
		dev.off() 
}

