"graph.ldaTest" <-
function(
	ldaTest, xax=1, yax=2, plot.what="p.assign", binary=NULL, 	
	centroids=TRUE, ell=TRUE,  sites=TRUE, stars=TRUE, 
	alpha=0.95, filter.env=NULL, saveplot=FALSE, path=NULL, width=6, height=6, 
	xlim=NULL, ylim=NULL, lwd=1, len=0.1, 
	lty.env=1, lty.ell=1, lty.axis=2, lty.stars=1, 
	col.env="blue", col.groups=NULL, col.ell="black", col.ctd="black",
	pos.env=4, pos.bin=4, pos.site= NULL, pos.ctd=4,
	cex.env=1, cex.site=1, cex.ctd=1, cex.axis=1,
	pch.bin=21, pch.site=21, pch.ctd=23, 
	ell.axis=FALSE, mul.env=0.9
	){

# Axis reversion filter
	if(saveplot==TRUE){
		if(is.null(path)){
			cat("Type a file path and the pdf filename you which to create: ex.: 
				'~/Desktop/test.pdf","\n")
			path<-scan(file="",what="character",quiet=TRUE,nline=1)
		}else{}
		pdf(file = path, onefile = TRUE,width=width,height=height, 
			family="Helvetica",
			pagecentre=TRUE)
	}else{
		dev.size(w=width,h=height)
	}	
	xinv<-1
	if(xax<0){
		xinv<-(-1)
		xax<--(xax)
	}else{}
	yinv<-1
	if(yax<0){
		yinv<-(-1)
		yax<--(yax)
	}else{}
	#("model","p.observe","p.assign")
	if(plot.what=="model"){
		F<-ldaTest$F.model
		Grp.Ctr<-ldaTest$Grp.Ctr.Mod
		groups<-ldaTest$Grp.Mod
		titre="Data and groupments used to build the model"
	}else if(plot.what=="observe"){
		F<-ldaTest$F.predict
		Grp.Ctr<-ldaTest$Grp.Ctr.Obs
		groups<-ldaTest$Grp.Obs
		titre="Validation data and observed groupments"
	}else{
		F<-ldaTest$F.predict
		Grp.Ctr<-ldaTest$Grp.Ctr.Ass
		groups<-ldaTest$Grp.Ass
		titre="Validation data and groupments assign by the model"
	}
	if(is.null(col.groups)){
		col.groups<-palette(heat.colors(length(levels(groups))))
	}else{}
	
	if(xax > ncol(F))
		stop("Their are not so many canonical axis; change the xax value")
	if(yax > ncol(F))
		stop("Their are not so many canonical axis, change the yax value")
	
# Text adaptation
	var.axis=round(unlist(ldaTest$canEigval)/sum(unlist(ldaTest$canEigval))*100, dig=2)
	plot(xinv*F[,xax],yinv*F[,yax],xlim =xlim,ylim=ylim,asp=1,
		xlab=paste("Canonical axis ",xax,"  ( ",var.axis[xax],"% )",sep=""),
		ylab=paste("Canonical axis ",yax,"  ( ",var.axis[yax],"% )",sep=""),
		type="n", cex.axis=cex.axis)
	# Print zero axis
	abline(h = 0, lty = lty.axis, lwd=lwd)
    abline(v = 0, lty = lty.axis, lwd=lwd)

	groups<-as.factor(groups)
	groups.levels=levels(groups)
	coll=1
	for(i in groups.levels){
		numb<-which(groups==i)
		if(sites==TRUE){
			if(pch.site>=21 & pch.site<=25){
				points(x=xinv*F[numb,xax], yinv*F[numb,yax], pch=pch.site, 
				bg=col.groups[coll], cex=cex.site)
			}else{
				points(x=xinv*F[numb,xax], yinv*F[numb,yax], pch=pch.site, 
				col=col.groups[coll], cex=cex.site)	
			}
		}else{}
		if(stars==TRUE){
			arrows(x0=xinv*Grp.Ctr[xax,coll], y0=yinv*Grp.Ctr[yax,coll], 
				x1=xinv*F[numb,xax], y1=yinv*F[numb,yax], length=0, 
				col=col.groups[coll], lty=lty.stars, lwd=lwd)
		}else{}
		if(ell==TRUE){
			ellipse(XY.mat=cbind(xinv*F[numb,xax],yinv*F[numb,yax]),
			alpha=alpha, ell.type=lty.ell, ell.lwd=lwd, p.axis=ell.axis,
		 	col=col.ell)
		}else{}
		coll=coll+1
	}
	
	#Plot centroids
	if(centroids==TRUE){
		if(pch.ctd>=21 & pch.ctd<=25){
			points(x=xinv*Grp.Ctr[xax,], yinv*Grp.Ctr[yax,], pch=pch.ctd, 
				bg=col.ctd)
		}else{
			points(x=xinv*Grp.Ctr[xax,], yinv*Grp.Ctr[yax,], pch=pch.ctd, 
				col=col.ctd)
		}
		text(x=xinv*Grp.Ctr[xax,], y=yinv*Grp.Ctr[yax,], labels=as.character(groups.levels), col=col.ctd, cex=cex.ctd, pos=pos.ctd)
		#print((Grp.Ctr))
		
	}else{}

	if(is.null(filter.env)){
		keep.env=c(1:nrow(ldaTest$C))
	}else{
		tmp<-apply(ldaTest$C[,c(xax,yax)]^2,1,function(x) sqrt(sum(x)))
		tmp<-tmp/sum(tmp)
		keep.env<-which(tmp>=filter.env)
	}
	mult.env<-multi.factor(F,ldaTest$C[keep.env,],xax=xax,yax=yax, percentage=mul.env)
	if(is.null(binary)){
		remain<-keep.env
	}else{
		bin<-which(unlist(lapply(keep.env, function(x) 
			length(grep(x,binary)))) ==1)
		remain<-keep.env[-bin]
		if(pch.bin>=21 & pch.bin<=25){
			points(xinv*ldaTest$C[keep.env[bin],xax]*mult.env, 
				yinv*ldaTest$C[keep.env[bin],yax]*mult.env, lty=lty.env, 
				bg=col.env, lwd=1, pch=pch.bin)
		}else{
			points(xinv*ldaTest$C[keep.env[bin],xax]*mult.env, 
				yinv*ldaTest$C[keep.env[bin],yax]*mult.env, lty=lty.env, 
				col=col.env, lwd=1, pch=pch.bin)
		}
		text(x=mult.env*xinv*ldaTest$C[keep.env[bin],xax], 
			y=mult.env*yinv*ldaTest$C[keep.env[bin],yax], 
			rownames(ldaTest$C)[keep.env[bin]], pos=pos.bin, col = col.env, 
			cex=cex.env)
	}
	if(length(remain)!=0){
		arrows(x0=0, y0=0, xinv*ldaTest$C[remain,xax]*mult.env,
			yinv*ldaTest$C[remain,yax]*mult.env, lty=lty.env, col=col.env, 
			code=2, len=len, lwd=1)
		text(x=mult.env*xinv*ldaTest$C[remain,xax], 
			y=mult.env*yinv*ldaTest$C[remain,yax], 
			rownames(ldaTest$C)[remain],  pos=pos.env, col = col.env, 
			cex=cex.env)
    }else{}
	
	# Close the drawn plot
	if(saveplot==TRUE)
		dev.off()
}

