"histo" <-
function(sonardata, Flags, n){

# DESCRIPTION

# Creating a "n" rank histogram of the values found on each line.  
# The ranks a constructed based the fact that the matrix lowest value is 0, and
# it's maxima is the matrix highest value

# INPUT

# sonardata			The data matrix containing the sonar return intensity values
# Flags				A Vector of marker describing how many echoes are within one
#					return
# n					The number of ranks to be used

# NOTES

# Values of 0, are not count since they were used to filling the blank created
# by short echoes versus long ones

	necho<-nrow(sonardata)
	histo<-matrix(NA, necho, n)
	maxval<-max(sonardata, na.rm=TRUE)
	borne<-t(matrix(c(1/10000000000, seq(maxval/n, (maxval-maxval/n), maxval/n),
		seq(maxval/n, maxval, maxval/n)), n, 2))
	use<-which(Flags>=1)
	for(j in use){
		for(i in 1:ncol(borne)){
			histo[j,i]<-length(which(sonardata[j,]>borne[1,i] & 
				sonardata[j,]<=borne[2,i]))
		}
	}
	colnames(histo)<-paste("Histo", c(1:n), sep="")
	return(histo)
}

