"imagenex.txt" <-
function(path=NA, echolength=NA, quiet=FALSE, j.refdate, 
	dateformat="%d-%m-%Y", timesep=":"){
	
# DESCRIPTION

# Import either one or multiple successive imagenex .TXT files

# INPUT

# Filepath 		A vector of paths "~/... imagenex file.txt converted from .81b
#				The default is NA. File will be asked.			
# number.file 	How many files to select if no Filepath have been specified.
#				The default is 1.
# echolength 	How long or how many intensity values constitute one echo.
#				Default is NA
# quiet			Minimise the amount of printed information

# OUTPUT

#Returns the corrected imagenex.txt and the files paths

	if(is.na(echolength))
		stop("Please provide a value for echolength")
	# DATA importation 
 	#Keeping: time, acquisition angle, altitude, sonar intensity*echolength
	source("~/STATSR/_Subroutines/_Convert/time2spm.R")
	number.file=length(path)
	tmp<-scan(path, what="character", quiet=TRUE)
	tmp<-t(matrix(tmp, ncol=length(tmp)/(echolength+9)))
	return(tmp)
	realtime<-tmp[,3]
	
	tmp[,3]<-time2spm(tmp[,2], j.refdate, dateformat, time = tmp[,3], timesep)
	print(tmp[,3])
	tmp<-tmp[,-c(1, 2, 4:7)] #8 is the angle value
	tmp1<-dim(tmp)
	imagenex.txt<-matrix(as.numeric(tmp), nrow=tmp1[1], ncol=tmp1[2])
	return(imagenex.txt)
}

