"import.nav" <-
function(path=NA, number.file=1, quiet=FALSE){
	#IMPORT EITHER ONE OR MULTIPLES SUCESSIVE outputctr.TXT FILES 
	#path is a vector of paths "~/.../.../... output.ctr file.txt  with the following items in:
	#"GPS time of fix","GPS x","GPS y","GPS z","GPS RMS","AM time of fix","AM x","AM y","AM z","AM RMS","Relay time of fix","Relay x","Relay y","Relay z","Relay RMS","Rov depth (m)","Rov altimiter","Rov Gyro deg","Total RMS")
	#number.file describes how many files to select if no path have been specified
	#echolength tells how long or how many intensity values constitute one echo...
	
	if(number.file>=2 | length(path)>=2){
		if(quiet!=TRUE){
			cat("FOR A MULTIPLE FILE IMPORTATION,",
				"PLEASE SELECT THE FILES IN A CHRONOLOGICAL ORDER!","\n")
		}else{}
	}else{}
	if(!is.na(path[1])){
		number.file=length(path)
		path<-check.file(path)	
	}else{
		path<-rep(NA, number.file)
		path<-check.file(path)
	}
	
	nomcol<-c("GPS time of fix","GPS x","GPS y","GPS z","GPS RMS",
		"AM time of fix","AM x","AM y","AM z","AM RMS",
		"Relay time of fix","Relay x","Relay y","Relay z","Relay RMS",
		"Rov depth (m)","Rov altimiter","Rov Gyro deg","Total RMS")
	
	for(i in 1:number.file){
		tmp<-scan(path[i],sep="\t",quiet=TRUE)
		tmp<-t(matrix(tmp,nrow=19))
		tmp<-tmp[,c(11:13,16,18,19)]
		if(i!=1)
			nav.datum<-rbind(nav.datum,tmp)
		else
			nav.datum<-tmp	
	}
	tmp1<-dim(nav.datum)
	nav.datum<-matrix(as.numeric(nav.datum),nrow=tmp1[1],ncol=tmp1[2])
	colnames(nav.datum)<-nomcol[c(11:13,16,18,19)]

	rm(tmp,tmp1)
	if(length(which(nav.datum[2:nrow(nav.datum),1]- 	
		nav.datum[1:nrow(nav.datum)-1,1]<=0))!=0){
		cat("Wrong time value are found in the files.\n", 
		"This is caused either by :", "\n",
		" 1- Wrong chronology","\n",
		" 2- Time value duplication","\n",
		" 3- Sampling starting before and ending after midnight\n",sep="")
		cat("The imagenex.txt output must be filtered", 
			"and corrected prior to analysis\n")
		cat("Do you want to see which rows of the matrix",
			"seams to have been aquired before the previous echo;", 
			"Yes=1 or No=0\n")
		tmp<-scan("",quiet=TRUE, n=1)
		if(tmp==1)
			cat(which(nav.datum[2:nrow(nav.datum),1]- 	
				nav.datum[1:nrow(nav.datum)-1,1]<=0)+1,"\n")
		}else{}
		#	s$sonarfilepath<-path
	return(nav.datum)
}

