"meanecho" <-
function(datum, sonardata, g=1, sec=FALSE, transect.limits=NULL) { #matrice, groupe
	library(datasets)
	#sec does average on one second basis

	#This first section is to make sure that echos from different transect are not averaged together
	if(!is.null(transect.limits)){
		transectspm<-matrix(as.numeric(transect.limits[,2:3]),ncol=2)
	}else{
		stop("The transect.limits matrix is required\n")
	}
#	Int03	<-c("14:45:43.32", "14:47:33.56")
#	Int03.2	<-c("14:50:57.71", "14:58:34.53")
#	Int04	<-c("15:03:30.03", "15:09:52.42")
#	Int05	<-c("15:15:47.62", "15:21:25.14")
#	Int05.2	<-c("15:30:49.99", "15:38:23.13")
#	Int06	<-c("15:44:26.46", "15:53:45.38")
#	Int07	<-c("16:14:35.65", "16:22:55.47")
#	Int08	<-c("16:27:58.11", "16:40:24.28")
#	Int09	<-c("16:42:50.98", "16:53:48.94")
#	Int10	<-c("16:57:36.22", "17:04:46.23")
#	Int11	<-c("17:10:12.65", "17:17:21.51")
#	Int12	<-c("17:21:34.94", "17:28:02.54")
#	Holens1<-c(" 18:46:29.71", "19:39:24.79")
#	Altlava1	<-c("19:55:02.64", "19:56:53.65")
#	Altlava1.1	<-c("19:58:57.78", "20:04:03.94")
#	Altlava2	<-c("20:07:07.72", "20:12:31.89")
#	Altlava3	<-c("20:13:40.98", "20:18:54.00")
#	Altperi1	<-c("20:23:34.56", "20:29:28.23")
#	Altperi2	<-c("20:31:01.82", "20:37:08.83")
#	Altperi3	<-c("20:40:50.68", "20:48:09.15")
#	Alttube1	<-c("20:52:31.91", "20:59:03.86")
#	Alttube2	<-c("21:02:34.11", "21:06:36.99")
#	Alttube3	<-c("21:10:38.56", "21:13:48.43")
#	Alttube4	<-c("21:18:47.72", "21:22:29.35")
#	Altlimp1	<-c("21:32:00.68", "21:37:24.03")
#	Altlimp2	<-c("21:39:17.18", "21:44:13.55")
#	Altlimp3	<-c("21:46:48.94", "21:49:58.76")
#	Altclam1	<-c("21:54:44.81", "21:58:02.43")
#	Altclam2	<-c("22:02:26.02", "22:05:54.96")
#	Altclam2.2	<-c("22:06:47.85", "22:10:38.54")
#	Altclam3	<-c("22:19:28.02", "22:22:48.39")
#	
	indices<-rep(NA, nrow(datum))
	if(sec==FALSE){   
	#### Do the mean per group
		mrk<-1
		for(ii in seq(1, length(transectspm), by=2)){	
			tt<-which(datum[,mn("TimeSPM", mat=datum)]>=transectspm[ii] &
			datum[,mn("TimeSPM", mat=datum)]<=transectspm[ii+1])
			if(length(tt)!=0){
				r<-ceiling(length(tt)/g) 
				indices[tt]<-rep(mrk:(mrk+r), each=g, length.out=length(tt))
				mrk<-mrk+r+1
			}else{}
		}
	}else{		
	#### Average each intensity found within 1 second
		ttt<-0
		for(ii in seq(1, length(transectspm), by=2)){	
			tt<-which(datum[,mn("TimeSPM", mat=datum)]>=transectspm[ii] & 		  
			datum[,mn("TimeSPM", mat=datum)]<=transectspm[ii+1])
			if(length(tt)!=0){
				indices[tt]<-trunc(datum[tt,mn("TimeSPM", mat=datum)])
			}else{
				#indices remain NA
			}
		}
	}
	sonardata<-do.call('rbind', 
    lapply(split(seq(nrow(sonardata)),  indices), 
        function(x) 
        if(length(x)>=2){ 
        	colMeans(sonardata[x,], na.rm=TRUE)
        }else{
        	sonardata[x,]
        }))

	datum<-do.call('rbind', 
    lapply(split(seq(nrow(datum)), indices), 
        function(x) 
        if(length(x)>=2){ 
        	colMeans(datum[x,], na.rm=TRUE)
        }else{
        	datum[x,]
        }))

	return(list(sonardata=sonardata, datum=datum))
}

