"nav4sonar2" <-
function(import.datum=NA,import.nav=NA,starttime=NULL,endtime=NULL,
sonarpositionoffset=c(0,0),headswap=-90,plot.show=TRUE,
plot.save=NULL, quiet=TRUE, timelaps=13.333/1000000, reson=25, soundspeed=1500,
tooweak=150){
#, maxseuil(findalt), trigger(alt.filter)){
########
######## Futur modification, the import.nav must have date and time column.
########
	navfilepath<-c("~/STATSR/Alls$navdata.txt")
	sonarfilepath<-c("~/STATSR/transect/HOLENS1.TXT")
	#sonarfilepath<-c("~/STATSR/transect/BATH1.TXT",
	#"~/STATSR/transect/BATH2.TXT",
	#"~/STATSR/transect/BATH3.TXT",
	#"~/STATSR/transect/BATH4.TXT",
	#"~/STATSR/transect/BATH5.TXT",
	#"~/STATSR/transect/BATH5_2.TXT",
	#"~/STATSR/transect/BATH6.TXT",
	#"~/STATSR/transect/BATH7.TXT",
	#"~/STATSR/transect/BATH8.TXT",
	#"~/STATSR/transect/BATH9.TXT",
	#"~/STATSR/transect/BATH10.TXT",
	#"~/STATSR/transect/BATH11.TXT",
	#"~/STATSR/transect/BATH11_2.TXT",
	#"~/STATSR/transect/BATH12.TXT",
	#"~/STATSR/transect/BATH4_2.TXT")
	#navfile=navfilepath;sonarfile=sonarfilepath;
	#starttime=NULL;endtime=NULL;
	sonarpositionoffset=c(0.325,0.32,0.90);headswap=0;
	#plot.show=TRUE;plot.save=TRUE;quiet=TRUE


	if(is.na(import.datum[1]))
		stop("import.datum is a required field\n")
 	if(is.na(import.nav[1]))
		stop("import.nav is a required field\n")
 	
 	s<-list()
 	#Seconds based
	s$timelaps=timelaps/1000000
	s$soundspeed=soundspeed/1000000
	
	s$j.refdate<-import.datum$j.refdate
	s$sonarfile<-import.datum$path
	s$sonardata<-import.datum$datum
	s$navdata<-import.nav
	rm(import.nav,import.datum)
	
	lct <- Sys.getlocale("LC_TIME")
	Sys.setlocale("LC_TIME", "C")
	tmp<-range(s$sonardata[,1])
	if(length(plot.save)!=0){
		if(plot.save==TRUE){
			cat("The graphics output folder is created in the folder where the first sonar file was selected\n")
			plotdir<-paste(dirname(s$sonarfile[1]),"_NavGraphics",sep="/")
			dir.create(plotdir,showWarnings=FALSE)
			plot.save<-plotdir
		}else{}
	}else{}
	
	if(length(starttime)==0)
		starttime<-max(which(s$navdata[,1]<=trunc(tmp[1])))
	
	if(length(endtime)==0)
		endtime<- min(which(s$navdata[,1]>=round(tmp[2])))
	s$navdata<-s$navdata[starttime:endtime,]
	rm(tmp)

	#### Intensity value smoothing
	a<-system.time(s$lisse<-lissagepargroupe(s$sonardata[,-c(1:3)], g=21, 
		method="mean",rem=reson)$lisse)
	a[3]<-sprintf("%.2f", a[3])
	jkl=1
	cat(jkl,"-  Echoes smoothing, completed in", a[3], "sec!\n")
	jkl=jkl+1
	tmp0<-findalt(lisse=s$lisse, p=0.8, tooweak=tooweak,
		soundspeed=s$soundspeed, timelaps=s$timelaps, maxseuil=14000*0.005)
	tmp<-which(tmp0[,3]>=0)
	if(length(tmp)!=0){
		s$sonardata<-s$sonardata[tmp,]
		s$newalt<-tmp0[tmp,1]
	}else{
		s$newalt<-tmp0[,1]	
	}
	#return(list(s$sonardata=s$sonardata,s$newalt=s$newalt))
	#Vrifie la qualit de notre estimation de l'altitude
	a<-system.time(altitudecompare(x=s$sonardata[,1], alt1=s$sonardata[,3], 
		alt2=s$newalt,alt1col="red", alt2col="blue", width=6, height=6,
		plot.show=plot.show,plot.save=plot.save,
		main="Comparaison des valeurs d'altitude, Imagenex vs Moi"))
	a[3]<-sprintf("%.2f", a[3])
	cat(jkl,"-  Altitude comparison completed in", a[3], "sec!\n")
	jkl=jkl+1
	#Filtre les mauvaise valeures d'altitude:
	a<-system.time({
		tmp<-altitude.filter(x=s$sonardata[,1], alt=s$newalt, trigger=0.6, 	
			width=6,height=6, plot.show=plot.show, plot.save=plot.save, 
			quiet=quiet)
		if(length(tmp$rem)!=0){
			s$sonardata<-s$sonardata[-tmp$rem,]
			s$newalt<-tmp$alt
		}else{}
	})
	a[3]<-sprintf("%.2f", a[3])
	cat(jkl,"-  Altitude filtering completed in", a[3], "sec!\n")
	jkl=jkl+1
	#Trouve les valeurs de profondeurs errones
	
	a<-system.time({
		tmp<-depth.filter(x=s$navdata[,1], depth=s$navdata[,4], varlimit=10, 
			width=6, height=6, plot.show=plot.show, plot.save=plot.save,
			quiet=quiet)$rem
		if(length(tmp)!=0)
			s$navdata<-s$navdata[-tmp,]
	})
	a[3]<-sprintf("%.2f", a[3])
	cat(jkl,"-  Depth filtering completed in", a[3], "sec!\n")
	jkl=jkl+1
	#Vrifier la qualit des positions 
	a<-system.time({
		keep<-area.select(nav=s$navdata[,2:3])$keep
		#s$navdata<-s$navdata2
		if(length(keep)!=0){
			s$navdata<-s$navdata[keep,]
		}else{
			stop("Upon the selection of the working area",
				"none of the navigation was kept\n")
		}
	})
	a[3]<-sprintf("%.2f", a[3])
	cat(jkl,"-  Working area selection completed in", a[3], "sec!\n")
	jkl=jkl+1
	
	#Filter the nav	
	a<-system.time({
		tmp<-navquality.filter(s$navdata[,c(1,6)], maxrms=20, width=6, height=6, 
			plot.show=plot.show, plot.save=plot.save, quiet=quiet)$rem
		if(length(tmp)!=0)
			s$navdata<-s$navdata[-tmp,]
		tmp<-velocity.filter(s$navdata[,1:3], speedlimit=0.7, width=6, height=6, 
			plot.show=plot.show, plot.save=plot.save, quiet=quiet)$rem
		if(length(tmp)!=0)
			s$navdata<-s$navdata[-tmp,]
	})
	a[3]<-sprintf("%.2f", a[3])
	cat(jkl,"-  Velocity filtering completed in", a[3], "sec!\n")
	jkl=jkl+1

	#X and Y Corrections using the offsets given for the distance between the GPS antenna (rov beacon) and the sonar head
	#Time to get prediction for limited by memory size while performing krigging
	sel<-seq(1,nrow(s$sonardata),by=10)
#	return(list(s$sonardata=s$sonardata, sel=sel, newalt=s$newalt, s$navdata=s$navdata))
	#Based on the sonar altitude found we interpol the altitude value each of the nav position based on time
	a<-system.time({
		s$navdata<-cbind(s$navdata, 	
			round(spline.inter(modelx=s$sonardata[sel,1], modely=s$newalt[sel],
			estimy=s$navdata[,1])$y, digit=2))
		colnames(s$navdata)<-c(colnames(s$navdata)[1:6], "Newalt")
	})
	a[3]<-sprintf("%.2f", a[3])
	cat(jkl,"-  Altitude interpolation completed in", a[3], "sec!\n")
	jkl=jkl+1
	
	#X and Y Corrections using the offsets given for the distance between the GPS antenna (rov beacon) and the sonar head
	#Time to get prediction for limited by memory size while performing krigging
	#print("please verify the sel you use EITHER 50 for holens and bathy", 
#		"more for INT")
	sel<-seq(1,nrow(s$sonardata),by=1)
	#Based on the depth readings found with every nav positions, we interpol a depth reading for every sonar sample
	a<-system.time({
		depthvalue<-spline.inter(modelx=s$navdata[,1], modely=s$navdata[,4], 
			estimy=s$sonardata[sel,1])
	})
	a[3]<-sprintf("%.2f", a[3])
	cat(jkl,"-  Depth interpolation completed in", a[3], "sec!\n")
	jkl=jkl+1
	
	#Based on the gyro readings found with every nav positions, we interpol a gyro reading for every sonar sample
	#Trouve les valeurs de gyro
	a<-system.time({
		gyro<-gyro.inter(timespm=s$navdata[,1], gyro=s$navdata[,5], 
			estim.time=s$sonardata[sel,1], plot.save=plot.save, plot.show==TRUE)
	})
	a[3]<-sprintf("%.2f", a[3])
	cat(jkl,"-  Gyro interpolation completed in", a[3], "sec!\n")
	jkl=jkl+1
	
	ok<-0
	spar=0.2
	while(ok!=1){
		#Trouve les valeurs de x et y pour chaque ping
		a<-system.time({
			tmp<-nav.inter(timespm=s$navdata[,1], x=s$navdata[,2], 		
				y=s$navdata[,3], weight=1/s$navdata[,6], all.knots=TRUE, 
				estimy=s$sonardata[sel,1], spar=spar)
		})
		a[3]<-sprintf("%.2f", a[3])
		cat(jkl,"-  Navigation interpolation completed in", a[3], "sec!\n")
		jkl=jkl+1
	
		#Trouvons la position de la tte du sonar s'il n'est pas  la mme position que l'antenne
		a<-system.time({
			tmp1<-nav.offset.corr(x=tmp$x, y=tmp$y, 
			sonaroff=sonarpositionoffset, gyro=gyro, altitude=s$newalt[sel], 
			depth=depthvalue$y, headswap=headswap, headangle=s$sonardata[sel,2])
		})
		a[3]<-sprintf("%.2f", a[3])
		cat(jkl,"-  Offset correction completed in", a[3], "sec!\n")
		jkl=jkl+1
	
		navplusfootprints(xnav=s$navdata[,2], ynav=s$navdata[,3], xfoot=tmp1$x, yfoot=tmp1$y, width=6, height=6, plot.show=TRUE, plot.save=NULL, main="GPS Beacon and footprint path")	
		ok1<-1
		while(ok1!=0){
			cat("Do you want to zoom in the recently created plot?",
				"YES=1, No=0\n")
			ok1<-scan("", nlines=1, quiet=TRUE)
			if(ok1!=0){
				cat("Select two opposite corners of the area you want",
					"to zoom in\n")
				tmp00<-locator(2)
				navplusfootprints(xnav=s$navdata[,2], ynav=s$navdata[,3], 
					xfoot=tmp1$x, yfoot=tmp1$y, 
				xlim=c(min(tmp00$x), max(tmp00$x)), 
				ylim=c(min(tmp00$y), max(tmp00$y)), 
				width=6, height=6, plot.show=TRUE, plot.save=NULL, 
				main="GPS Beacon and footprint path")
			}else{}
		}#Graphiques localisant le chemin des empreintes sonores
		cat("Are you satified by the interpolation results; YES=1 NO=0")
		ok<-scan("", nlines=1, quiet=TRUE)
		if(ok!=1){
			cat("Type a new spar value to be used, which previously was", 
				spar,"\n")
			spar<-scan("", nlines=1, quiet=TRUE)
		}else{
			if(length(plot.save)!=0){
				nom<-"Navpath"
				path<-paste(plot.save, "/", nom, ".pdf", sep="")
				pdf(file = path, onefile = TRUE, width=6, height=6,  
					family="Helvetica", encoding="MacRoman.enc", 
					pagecentre=TRUE)
				navplusfootprints(xnav=s$navdata[,2], ynav=s$navdata[,3], 
					xfoot=tmp1$x, yfoot=tmp1$y, 
				xlim=c(min(tmp00$x), max(tmp00$x)), 
				ylim=c(min(tmp00$y), max(tmp00$y)), 
				width=6, height=6, plot.show=FALSE, plot.save=path, 
				main="Corrected navigation path")
				dev.off()
			}else{}
		}
	}
	name=c("X", "Y", "Depth", "Altitude")
	nav=cbind(tmp1$x, tmp1$y, tmp1$depth, tmp1$altitude)
	colnames(nav)=name
	Sys.setlocale("LC_TIME", lct)
	return((nav=nav))
}

