"navquality.filter" <-
function(nav,maxrms=0.7,width=6,height=6,plot.show=TRUE,plot.save=NULL,quiet=TRUE){
#The submarine maximum speed is 5 knots (5 miles nautiques  l'heure)
#1 miles nautiques = 1.852 km
#5 miles nautiques = 9.26 km = 9260 m
#Vitesse maximales m/seconde = 2.57
#3 knots= 1.54 m/s
#using 1 for bathy and 0.7 for holens

#nav is a i by 3 matrix in which in column we found time x and y positions in utm values (meters references)
#speedlimit is in meters per seconds
	mrk<-1
	nn<-0
	rem<-NULL
	nbrow<-nrow(nav)
	rem<-which(nav[,2]>maxrms)
	if(length(rem)!=0){
		if(length(plot.save)!=0){
			nom<-"navquality"
			path<-paste(plot.save,"/",nom,".eps",sep="")
			postscript(file = path,paper="special", onefile = TRUE,width=width,height=height, family="Helvetica", encoding="MacRoman.enc",pagecentre=TRUE)
			plot(x=nav[,1],y=nav[,2],main="Original and filtered navigation values");
			lines(x=nav[-rem,1],y=nav[-rem,2],col="red")
			dev.off()
		}else{}
		if(plot.show==TRUE){
			dev.size(w=width,h=height)
			plot(x=nav[,1],y=nav[,2],main="Original and filtered navigation values");
			lines(x=nav[-rem,1],y=nav[-rem,2],col="red")
		}else{}
	}else{}
	
	if(quiet==FALSE)
		cat("The nav points removed by the navigation filter are the following:",rem,"\n")
	if(length(rem)!=0)
		nav<-nav[-rem,]
	return(list(rem=rem,nav=nav))
}

