"norm.temporal" <-
function(norm.puis,newspacing,timelaps,depth.ref,NewAlt){ 

# DESCRIPTION

# This complete the depth normalisation procedure. Because the size of the 
# footprint varies with altitude the time the sonar passed on the sampled area differs.
# Consequently such variation is corrected by either compressing or strettching
# the sonar return, which consequently has to be resampled.

# INPUT

# norm.puis		Data power normalized 
# newspacing	Newspacing that will be used in the resampling procedure
# timelaps		Original spacing between the intensity values
# depth.ref		The reference depth to which all sonar return shall be set 
# NewAlt 		The altitude value use for the temporal correction

	library(datasets)
	library(splines)
	necho<-nrow(norm.puis)
	lecho<-ncol(norm.puis)
	
	#### Temporal correction for the first echo, it end up also been used for 
	#### the second
	
	#### This value was through visual validation and should be reevaluated
	#### for a new sonar surveys
	n<-1/3
	proportion<-(NewAlt/depth.ref)^(n)
	
	#### Temporal correction for the second return.
	proportion2<-(NewAlt/depth.ref)^(n)  #Not used
	
	# Stop the temporal correction set the following values
	# s$proportion<-1; s$proportion2<-1
	#### Find the maximum values that represent the first echo within the output 
	#### matrix once time corrected 
	numb<-max(as.integer(((lecho-1)*timelaps/proportion)/newspacing)+1,na.rm=TRUE)
	norm.temp<-matrix(rep(0,necho*(numb)),necho,numb)
	for(j in 1:necho){
		xout<-seq(1,lecho,by=((newspacing*proportion[j])/timelaps))
		tmp<-approx(1:lecho,norm.puis[j,],xout=xout)$y
		value2<-rep(0,(numb-length(xout)))
		norm.temp[j,]<-c(tmp,rep(0,(numb-length(xout))))
	}
	return(list(norm.temp=norm.temp,TimeCorE1=proportion,TimeCorE2=proportion2))
}

