"splitByAlt" <-
function(mat, ID, alt.sect=NULL){

# DESCRIPTION

# Splits the data prior based on altitude section as required by the user
# prior to the analyses

# INPUT

# alt.sect 			See analyse.R

	data<-list()
		if(is.null(alt.sect)){
			mi<-round(min(ID[,2]), digit=2)
			ma<-round(max(ID[,2]), digit=2)
			data[[1]]<-cbind(ID, mat)
			names(data)[1]<-paste("Alt", mi, "to", ma, sep="")			
		}else{
			j<-1
			for(i in 1:nrow(alt.sect)){
				tmp<-which(ID[,2]>=alt.sect[i,1] & ID[,2]<alt.sect[i,2])
				if(length(tmp)<=1){
					cat("No more than one sonar return was acquired between", 
						alt.sect[i,1], "and", alt.sect[i,2], "m \n")
				}else{
					data[[j]]<-cbind(ID[tmp,], mat[tmp,]) 
					names(data)[j]<-paste("Alt", alt.sect[i,1], "to", 
						alt.sect[i,2], sep="")
					j<-j+1
				}
			}
		}
	return(data)
}

