"timeCheck" <-
function(datum, transect.limits, j.refdate, remove.all=TRUE, see=TRUE){

# DESCRIPTION 

# This function makes sure we use chronological sonar returns

# INPUT 

# datum				The data matrix produced by merging 
#					all input sonar data files
# transect.limits	The matrix givin each transect time boundaries
# remove.all		This removes all chronological errors
# see				This settings define if we which to see which echoes 
#					are removed, can be set to NA TRUE or FALSE

	transect.limits<-matrix(transect.limits, ncol=3)
	toto1<-as.numeric(transect.limits[,2])
	toto2<-as.numeric(transect.limits[,3])			
	test3=1
	counter=0
	mrk=0
	total<-nrow(datum)
	while(test3!=0){
		if(mrk==5){
			stop("There is still erroneous times in the file after 5 pass.\n",
			"Please check out if the file selection was made in a chronological order!\n If so, look where the errors occured and fix the specified file manually\n")
		}else{}	
		test2<-which(datum[2:nrow(datum),1]-datum[1:nrow(datum)-1,1]<=0)
		test3<-length(test2)
		if(test3!=0){
			if(mrk==0){
				cat("Wrong time value are found in the sonardata input files\n",
					"This can be caused by either one of the following:\n",
					"\t1- Wrong chronology", "\n",
					"\t2- Time value duplication", "\n", 
					"\t3- Sampling starting before and ending after midnight\n",
					sep="")
				cat("The datum output must be filtered,",
					"and corrected prior to analysis\n")
				if(is.null(see)){
					cat("Do you want to see which time values of the matrix",
					"seems to have been aquired before the previous echo;","
					Yes=1 or No=0\n")
					tmp<-scan("", quiet=TRUE, nlines=1)
					flush.console()
				}else{
					if(see==FALSE)
						tmp=0
					else
						tmp=1
				}
			}else{}
			mrk=mrk+1
			if(tmp==1){
				rem<-test2+1
				for(i in 1:length(rem)){
					toto3<-which(toto1<=datum[rem[i],1] & 
						toto2>=datum[rem[i],1])
					cat("Wrong time sequence was found at ", 
						spm2time(datum[rem[i],1], j.refdate)$times, 
						"in", transect.limits[toto3,1], "file \n")
				}
			}else{
				rem<-test2+1
			}
			if(remove.all!=TRUE){
				cat("Do you want to remove these rows from the dataset;",
					" Yes=1 or No=0")
				tmp0<-scan("", quiet=TRUE, nlines=1)
				if(tmp0==1){
					datum=datum[-rem,]	
				}else{
					stop("See if you can correct the file manually\n")
				}
			}else{
				datum=datum[-rem,]	
			}
		}else{
			if(mrk==1)
				cat("Out of ", total, " sonar returns, ", total-nrow(datum),
					" were removed\n", sep="")
		}
	}
	return(datum)
}

