"transf" <-
function(VI=NA, VE=NA, analyse="ALL"){

# DESCRIPTION

# The transformation is appplied on the raw unscaled data

# scaling will be performed after wards
VE.mrk=0
VI.mrk=0
VE.table=NA
if(analyse=="ALL" | analyse=="VT"){
	VE.mrk=1
	VI.mrk=1
}else{
	if(analyse=="VE"){
		VE.mrk=1
	}else{
		VI.mrk=1	
	}
}


	if(VI.mrk==1){
		necho<-nrow(VI)	
		#### Les donnes de dpart son entre 0 et 1
		#### int.vs.2r.as<-VI
		#### int.ve.ml.no<-VE
		
		#### Transformation of the VI matrix	
		#### Transformation step 1: Application of the double square root			
	
		VI<-(VI^(1/2))^(1/2)
		
		#### Transformation step 2: Arcsin Transformation
		#### Ref (arcsine transformation or angular transformation).: 
		#### p.419-421 Sokal and Rohlf, biometry, the principles and practice of 
		#### statistics in biological research, 1981 second edition 
		#### Specially appropriate for percentage and proportions: streches out 
		#### both tail of a distribution and compress de middle
		tmp <- apply(VI, 1, max,na.rm=TRUE);	
		VI<-2/pi*asin((sweep(VI, 1, tmp, "/"))^0.5)
	}else{}
	
	#### Transformation of the VE matrix
	#### Perform on each variable either no, sqrt, sqrt(sqrt()), or log 
	if(VE.mrk==1){
		#### Step 1: Could be every where, remove all variable that does not have
		#### any values
		
		mn<-0.0000001
		k<-rep(NA,4)
		VE.trans.sel<-list()
		VE.skew<-list()
		for(i in 1:ncol(VE)){
			vv<-var(VE[,i],na.rm=TRUE)
			if(vv!=0){
				#### Apply SQRT 
				v.r1<-(VE[,i])^0.5
				#### [4] stands for "skew"
				k[1]<-abs(mom(v.r1)[4])
				#### Apply DOUBLE SQRT 
				v.r2<-(VE[,i])^0.25
				k[2]<-abs(mom(v.r2)[4])
				#### Apply LOG 
				v.lg<-log(VE[,i]+1)
				k[3]<-abs(mom(v.lg)[4])
				#### Apply nothing
				v.no<-VE[,i]
				k[4]<-abs(mom(VE[,i])[4])
				trans.sel<-which.min(k)
			}else{
				v.no<-VE[,i]
				trans.sel<-4
				k[4]<-"NULL"
			}
			if(trans.sel==1){
				VE.trans.sel[i]<-"SQRT"
				VE.skew[i]<-k[1]
				VE[,i]<-v.r1
			}else{}
			if(trans.sel==2){
				VE.trans.sel[i]<-"DOUBLE SQRT"
				VE.skew[i]<-k[2]
				VE[,i]<-v.r2
			}else{}
			if(trans.sel==3){
				VE.trans.sel[i]<-"LOG"
				VE.skew[i]<-k[3]
				VE[,i]<-v.lg
			}else{}
			if(trans.sel==4){
				VE.trans.sel[i]<-"NONE"
				VE.skew[i]<-k[4]
				VE[,i]<-v.no
			}else{}	
			names(VE.trans.sel)[i]<-colnames(VE)[i]
			names(VE.skew)[i]<-colnames(VE)[i]
		}
		
		VE.table<-cbind(VE.trans.sel,VE.skew)
	}
	####  End of transformations
		
	#### Time to add the timespm values at the beginning of the matrices
	return(list(VE=VE,VI=VI,VE.table=VE.table))
}

