"velocity.filter" <-
function(nav,speedlimit=0.7,width=6,height=6,plot.show=TRUE,plot.save=NULL,quiet=TRUE){
#The submarine maximum speed is 5 knots (5 miles nautiques  l'heure)
#1 miles nautiques = 1.852 km
#5 miles nautiques = 9.26 km = 9260 m
#Vitesse maximales m/seconde = 2.57
#3 knots= 1.54 m/s
#using 0.7 for bathy and 0.7 for holens

#nav is a i by 3 matrix in which in column we found time x and y positions in utm values (meters references)
#speedlimit is in meters per seconds
	mrk<-1
	nn<-0
	rem<-NULL
	nav0<-nav
	nbrow<-nrow(nav)
	navspeed0<-sqrt((nav[1:(nbrow-1),3]-nav[2:nbrow,3])^2+(nav[1:(nbrow-1),2]-nav[2:nbrow,2])^2)/abs(nav[1:(nbrow-1),1]-nav[2:nbrow,1])
	while(mrk!=0){
		nbrow<-nrow(nav)
		navspeed<-sqrt((nav[1:(nbrow-1),3]-nav[2:nbrow,3])^2+(nav[1:(nbrow-1),2]-nav[2:nbrow,2])^2)/abs(nav[1:(nbrow-1),1]-nav[2:nbrow,1])
		toofast<-which(navspeed>=speedlimit)
		mrk=length(toofast)
		if(mrk!=0){
			nav<-nav[-min(toofast+1),]
			if(length(rem)!=0){
				rem<-c(rem,min(toofast+1+nn))
			}else{
				rem<-min(toofast+1+nn)
			}
			nn=nn+1
		}else{}
	}
	if(length(plot.save)!=0){
		nom<-"filter.velocity1"
		path<-paste(plot.save,"/",nom,".eps",sep="")
		postscript(file = path,paper="special", onefile = TRUE,width=width,height=height, family="Helvetica", encoding="MacRoman.enc",pagecentre=TRUE)
		plot(x=nav0[2:(nrow(nav0)),1],y=navspeed0,"l",main="Original and filtered velocity values");
		lines(x=nav[2:(nrow(nav)),1],y=navspeed,col="red")
		dev.off()
	}else{}
	
	if(plot.show==TRUE){
		dev.size(w=width,h=height)
		plot(x=nav0[2:(nrow(nav0)),1],y=navspeed0,"l",main="Original and filtered velocity values");
		lines(x=nav[2:(nrow(nav)),1],y=navspeed,col="red")
	
	}else{}
	
	if(quiet==FALSE)
		cat("The nav points removed by a velocity filter are the following:",rem,"\n")
	if(length(rem)!=0)
		nav<-nav0[-rem,]


	return(list(rem=rem,nav=nav))
}

