"vif" <-
function(mat, seuil=0.00000001, print.vif=TRUE){
#
# Cette fonction retourne un vecteur contenant les coefficients VIF 
# (Variance Inflation Factors) pour les variables explicatives X.
# Rfrence: p. 386 de
#    Neter, J. et al. 1996. Applied linear statistical models. 4th edition.
#    Richard D. Irwin Inc., Chicago.
#
# mat = matrice  filtrer pour la colinarit	
# seuil = seuil dfinissant  partir de quelle valeur propre une variable est
#    considre comme compltement explique par les variables prcdentes.
#    La valeur 0 est attribue  une variable ayant une valeur propre sous le seuil
#
# Sbastien Durand, mars 2005
#
	library(MASS)
	#Vrifie que nous soyons bien en prsence d'une matrice ayant plus d'une variable
	nb.col=dim(mat)[2]
	# Assigne 0 aux variables compltement expliques par les variable prcdentes
	mm=0
	if(nb.col>1){
		mat.cor<-cor(mat)
		for(i in 2:ncol(mat)){
			look<-c(1:i)
			if(mm!=0)
				look<-look[-mrk]
			if(det(mat.cor[look,look])<seuil){
				if(print.vif==TRUE){
					cat('\n')
					cat("Variable '",colnames(mat)[i],
						"' is collinear with the ones before: determinant is ", 	
						det(mat.cor),'\n')
				}else{}
				if(mm==0){
					mrk<-i
					mm<-1
				}else{
					mrk<-c(mrk,i)
				}
			}else{}	
		}
	}else{}
	if(mm==1){
		vif1<-diag(ginv(cor(mat[,-mrk])))
		vif0<-rep(0,length(mrk))
		vif<-c(vif0,vif1)
		nn<-1:ncol(mat)
		vif<-round(vif[sort(c(mrk,nn[-mrk]),index.return=TRUE)$ix],digit=2)
	}else{
		vif<-round(diag(ginv(cor(mat))),digit=2)
	}
	names(vif)<-colnames(mat)
	return(vif)
}

