\name{VIS.analysis}
\alias{VIS.analysis}
\docType{data}
\title{ Data set: Visual analysis of the benthos area sampled by the sonar beam}
\description{
  For every second of video recording, the physical and biological cover characteristics of the seafloor are described through 26 binary variables.
In case of doubt between different descriptors, the various competing descriptors received a fraction between 0 and 1; these fractions sum to 1.
}
\usage{data(VIS.analysis)}
\format{
 	A data table with n observations and p variables, in this case (2950 x 26):
	\item{ Date }{ Sampling date. Make sure the format is the same as the one
    	specified in the \code{\link{analyse}} function, 	
    	e.g.:\code{12-MAY-2001}.
    }
    \item{ Time }{ Sampling time (hour:min:sec, e.g.\code{14:51:35}). The area 
    	described is the one sampled by the sonar beam, not the whole area in
    	the video picture.
    }
    \item{ nextcolumns }{ Various variables. There are 24 binary variables in 
    	the example data set.
	}
}
\details{
  The present version of \code{\link{analyse}} will support only visual data that were obtained at one-second intervals.
}
\source{
  This is a small subset of the data that we used to describe hydrothermal habitats found in a hydrothermal vent field on the Juan de Fuca ridge.
}
\references{
}
\examples{
data(VIS.analysis)
VIS.analysis[1:3,]
}
\keyword{datasets}
