\name{sonarX}
\alias{sonarX}

\alias{check.file}		%requires a quick description
\alias{dev.size}		%requires a quick description


% ALL THE FOLLOWING FUNCTION ARE PART OF AN 
% UNFINISHED OPTION MEANT TO PRODUCE MAPS 
% AND OVERLAY THE SPECIFIC GROUPMENT INFO
% FOUND BY OUR ANALYSIS.
\alias{altitudecompare}  %GOES IN NAV2SONAR
\alias{area.select}		%GOES IN NAV2SONAR
	\alias{workarea}	%GOES IN NAV2SONAR
\alias{bathy.krig}	 	%GOES IN NAV2SONAR
\alias{depth.filter}	%GOES IN NAV2SONAR
\alias{gyro.inter}		%GOES IN NAV2SONAR
\alias{imagenex.txt}	%GOES IN NAV2SONAR  
% NOTE: This last alias can cause problem.
%		Another object is given the same 
%		name in the exxtract.R function.
\alias{import.nav}		%GOES IN NAV2SONAR
\alias{nav.inter}		%GOES IN NAV2SONAR
\alias{nav.offset.corr}	%GOES IN NAV2SONAR
\alias{nav4sonar}		%GOES IN NAV2SONAR
\alias{nav4sonar2}		%GOES IN NAV2SONAR
\alias{navplusfootprints}%GOES IN NAV2SONAR
\alias{navquality.filter}%GOES IN NAV2SONAR
\alias{outputctr}		%GOES IN NAV2SONAR
\alias{spline.inter}	%GOES IN NAV2SONAR
\alias{velocity.filter}	%GOES IN NAV2SONAR




\title{ The extraction and analysis of sonar signals for benthic habitat detection purposes
}
\description{ This packages is used to filter sonar returns and normalize them for depth. Following that, the first and second echoes are found in each sonar return. Three sets of parameters are created from the echo areas. The first data set contains intensity variables, \code{"VI"}. The second data set contains extracted variables, \code{"VE"}. The thrid data set, \code{"VT"}, contains the union of the VI and VE data sets. See \code{\link{analyse}}. 
Each variable found in the \code{"VI"} data set corresponds to a specific time interval in a sonar return; the variables form a time series describing the echo intensities as the signal rises and falls. The variables in the \code{"VE"} dataset are of different types; they describe characteristics of the echo shapes.
}
\details{
  HOW TO section:
  
  1- Import and convert the original sonar data into a known and usable format, see \code{\link{import.imatxt}}.
  
  2- Use the \code{\link{extract}} function to preform filtering, correction and variable extraction.
  
  3- Use the \code{\link{analyse}} function to analyse the datasets found in the \code{\link{extract}} function output list.
  
  4- Interpet the results visually using either the \code{\link{graph.ldaTest}} or the \code{\link{graph.rdaTest}} functions.
}
\references{ Clarke, P. A. and L. J. Hamilton. 1999. The ABCS program for the analysis of echo sounder returns for acoustic bottom classification. DSTO-GD-0215, Defence Science & Technology Organisation, Australia. 

Hamilton, L. J. 2001. Acoustic seabed classification systems, Defense Science & Technology Organisation.

Legendre, P. and L. Legendre. 1998. Numerical Ecology. Second English edition. Elsevier, Amsterdam.

Legendre, P., K. E. Ellingsen, E. Bjrnbom and P. Casgrain. 2002. Acoustic seabed classification: improved statistical method. Canadian Journal of Fisheries and Aquatic Sciences 59: 1085-1089.

MacQueen, J. 1967. Some methods for classification and analysis of multivariate observations. 281-297 in: Le Cam L.M. and J. Neyman [eds.] Proceedings of the Fifth Berkeley Symposium on Mathematical Statistics and Probability. Volume 1. University of California Press, Berkeley.
}

\author{ Sebastien Durand <Sebastien.Durand@UMontreal.ca> }
\seealso{ \code{\link{import.imatxt}}, \code{\link{extract}}, \code{\link{analyse}}, \code{\link{rdaTest}}, \code{\link{ldaTest}}, \code{\link{graph.rdaTest}}, \code{\link{graph.ldaTest}}}

\keyword{survey}
\keyword{manip}
\keyword{datagen}
\keyword{multivariate}
\keyword{ts}
\keyword{cluster}
\keyword{graphs}

