\name{vertical.transects}
\alias{vertical.transects}
\docType{data}
\title{ 
Data set: Imported sonar data acquired from vertical transects
}
\description{
  This RData file is the saved output of the \code{\link{import.imatxt}} function. This data file contains a random subset of only 500 lines, extracted from a much larger file whose data were acquired at altitudes ranging between 1 and 10 meters over the seafloor. Five different habitats were surveyed, but each vertical transect is about a single habitat type.
}
\usage{
data(vertical.transects)
}

\format{
  This list contains 4 elements:
  
	\item{ datum }{ This matrix contains the sonar return intensities. In the 
		first column are found the times and dates of acquisition, in seconds 
		past midnight of the reference date.
	}
	\item{ limits }{ This matrix contains the starting and ending times of the 
		two transects read by the \code{\link{import.imatxt}} function.
 	}
	\item{ j.refdate }{ A numerical value describing the reference date. See 	
		\code{\link{Date}}.
	}
	\item{ path }{ The paths to the sonar files read by the 
		\code{\link{extract}} function. 
	}
}


\examples{
# #This load the original data set imported using import.imatxt function 
# #These are sonar data acquired through vertical transects 
# #where each transect were acquired over only one habitat; 
# #five different habitats were sampled.

data(vertical.transects)
names(vertical.transects)

# #Treatement of the data set is done as follow:
# #extract.data<-extract( import.datum=vertical.transects, avegroup=1)

# #The resulting data is stored in the dataset "ALTextract"
# data(ALTextract)

# #Constructing a partition vector based on the acquisition times
# times<-time2spm(date=extract.data$VE[,1], time=extract.data$VE[,2], 
#	dateformat="\%Y-\%m-\%d") 
# lava<- time2spm(date=c("19-AUG-2002","19-AUG-2002"), 
# 	time=c("19:55:02.64","20:23:34.55")) 
# peri<- time2spm(date=c("19-AUG-2002","19-AUG-2002"), 
#	time=c("20:23:34.56","20:52:31.90"))
# tube<- time2spm(date=c("19-AUG-2002","19-AUG-2002"), 
# 	time=c("20:52:31.91","21:32:00.67"))
# limp<- time2spm(date=c("19-AUG-2002","19-AUG-2002"), 
#	time=c("21:32:00.68","21:54:44.80"))
# clam<- time2spm(date=c("19-AUG-2002","19-AUG-2002"), 
#	time=c("21:54:44.81","22:22:48.39"))
# class.vec<-rep(0,length(times))
#	for (i in 1:length(times)){
#		if(times[i]>=lava[1] & times[i]<lava[2]) class.vec[i]<-1
#		if (times[i]>=peri[1] & times[i]<peri[2]) class.vec[i]<-2
#		if (times[i]>=tube[1] & times[i]<tube[2]) class.vec[i]<-3
#		if (times[i]>=limp[1] & times[i]<limp[2]) class.vec[i]<-4
#		if (times[i]>=clam[1] & times[i]<clam[2]) class.vec[i]<-5
#	}
#	v<-class.vec
#	v[v==1]<-"Lava";
#	v[v==2]<-"Peri";
#	v[v==3]<-"Tube";
#	v[v==4]<-"Limp";
#	v[v==5]<-"Clam";
# class.vec<- factor(v)	

# #Linear discriminant analysis (LDA) is used for the analysis
# res<-analyse(extract.data=extract.data, VIS=NA, 
#	alt.sect=NULL, use= "VT", keep=NA, class.vec=class.vec, 
#	validation.perc=0.30, 
#	nperm=9, criterion="Calinski", select.grpmt=TRUE, flag=2, 
#	method="LDA", grpmts.plot=TRUE)
}
\keyword{datasets}
