#include <R.h>
#include <Rmath.h>
#include <stdio.h>
#include <stdlib.h>


void Rollmax(double *vec, int *windowlength, int *nr, int *nc, double *max);
void Rollmean(double *vec, int *windowlength, int *nr, int *nc, double *mean);
void Rollmed(double *vec, int *windowlength, int *nr, int *nc, double *med);
void Rollmin(double *vec, int *windowlength, int *nr, int *nc, double *min);

void Vecintalloc (int **vec, int n);
void Tabintalloc (int ***tab, int l1, int c1);
void Freeinttab (int **tab);
void Freeintvec (int *vec);
void Freetab (double **tab);
void Freevec (double *vec);
void Taballoc (double ***tab, int l1, int c1);
void Vecalloc (double **vec, int n);
void Vecintalloc (int **vec, int n);
int compare (const void * a, const void * b);

void Rollmax(double *vec, int *windowlength, int *nr, int *nc, double *max){
	// Declarations de variables C locales
	double **lvec;
	int g,h,i,j,k,r,limlow,limhigh, nrow, ncol, n;
    nrow=*nr;
    ncol=*nc;
    // Allocation memoire pour les variables C locales
	Taballoc(&lvec, nrow, ncol);
	k = 0;
    for (i=0; i<nrow; i++) {
        for (j=0; j<ncol; j++) {
            lvec[i][j] = vec[k];
            k = k + 1;
        }
    }
   	limlow=(*windowlength-1)/2;
	limhigh=ncol-limlow;
	n=0;
	for (r=0; r<nrow; r++) {
		for (i=0; i<ncol; i++) {
			g=n-1;
			if (i>=limlow && i<limhigh) { 	// la fentre mobile est complte
				h=i-limlow; 			// Bordure minimale de la fentre mobile
				j=i+limlow;			// Bordure maximale de la fentre mobile	 
				if (lvec[r][j]>=max[g]) {
					max[n]=lvec[r][j];
				} else {
					if (lvec[r][h-1]==max[g]) {
						max[n]=lvec[r][h];
						for (k = h; k <= j; k++) {
							if (lvec[r][k]>max[n]) { max[n]=lvec[r][k]; }
						}
					} else { max[n]=max[g];	}
				}
			} else {
				if (i<limlow) {			// Nous sommes au dbut de la srie
					h=0; 				// Bordure minimale de la fentre mobile
					j=i+limlow; 			// Bordure maximale de la fentre mobile
					if (i>0) {			// Initialisation  t faite
						if (lvec[r][j]>max[g]) { 
							max[n]=lvec[r][j];
						} else { max[n]=max[g]; }				
					
					} else {			// INITIAlISE lA PROCEDURE
						max[n]=lvec[r][i];
						for (k = h; k <= j; k++) {
							if (lvec[r][k]>max[n]) { max[n]=lvec[r][k]; }
						} 					
					}
				} else { 				// Nous sommes  la fin de la srie
					h=i-limlow;			// Bordure minimale de la fentre mobile
					j=ncol-1;	// Bordure maximale de la fentre mobile
					if (lvec[r][h-1]==max[g]) {
						max[n]=lvec[r][h];
						for (k = h; k <= j; k++) {
							if (lvec[r][k]>max[n]) { max[n]=lvec[r][k]; }
						} 
					} else { max[n]=max[g]; }			
				}
			}
		//Rprintf("g = %d\th = %d\tj = %d\tmax = %f\n",g,h,j,max[n]);		
		n=n+1;
		}
    }
   	free(lvec);
	lvec=NULL;
   }

////////////////////////////////////////////////
void Rollmean(double *vec, int *windowlength, int *nr, int *nc, double *mean){
	// Declarations de variables C locales
	double **lvec, sum;
	int g,h,i,j,k,r,limlow,limhigh, nrow, ncol, mrk, n, p;
    nrow=*nr;
    ncol=*nc;
    // Allocation memoire pour les variables C locales
	Taballoc(&lvec, nrow, ncol);
	k = 0;
    for (i=0; i<nrow; i++) {
        for (j=0; j<ncol; j++) {
            lvec[i][j] = vec[k];
            k = k + 1;
        }
    }
    limlow=(*windowlength-1)/2;
	limhigh=ncol-limlow;
	n=0;
	for (r=0; r<nrow; r++) {
		mrk=0;
		sum=0;
		for (i=0; i<ncol; i++) {
			g=i-(limlow+1);
			p=*windowlength;
			if (i>limlow && i<limhigh) { 	// la fentre mobile est complte
				h=i-limlow; 			// Bordure minimale de la fentre mobile
				j=i+limlow;			// Bordure meanimale de la fentre mobile	 
				sum=sum-lvec[r][g];
				sum=sum+lvec[r][j];
				mean[n]=sum/p ;
			} else {
				if (i<=limlow) {			// Nous sommes au dbut de la srie
					h=0; 				// Bordure minimale de la fentre mobile
					j=i+limlow; 			// Bordure meanimale de la fentre mobile
					p=j+1;
					// INITIAlISE lA PROCEDURE
					if(mrk==1){
						sum=sum+lvec[r][j];
						mean[n]=sum/p;
					}else{
						for (k = h; k <= j; k++) {
							sum=sum+lvec[r][k];
							mean[n]=sum/p; 
						}
					}
				} else { 				// Nous sommes  la fin de la srie
					h=i-limlow;			// Bordure minimale de la fentre mobile
					j=ncol-1;	// Bordure meanimale de la fentre mobile
					p=j-h+1;
					sum=sum-lvec[r][g];
					mean[n]=sum/p;		
				}
			}
		mrk=1;
		//Rprintf("g = %d\th = %d\tj = %d\tsum = %f\tp = %d\tmean = %f\n",g,h,j,sum,p,mean[n]);		
		n=n+1;
		}
    }
    free(lvec);
    lvec=NULL;
}
////////////////////////////////////////////////
void Rollmed(double *vec, int *windowlength, int *nr, int *nc, double *med){
	// Declarations de variables C locales
	double **lvec;
	double *lmed, *lmed2;

  	int g,h,i,j,k,r,limlow,limhigh, nrow, ncol, n, p,l,q;
    nrow=*nr;
    ncol=*nc;
    // Allocation memoire pour les variables C locales
	Taballoc(&lvec, nrow, ncol);
	Vecalloc(&lmed, *windowlength);
	k = 0;
    for (i=0; i<nrow; i++) {
        for (j=0; j<ncol; j++) {
            lvec[i][j] = vec[k];
            k = k + 1;
        }
    }
    limlow=(*windowlength-1)/2;
	limhigh=ncol-limlow;
	n=0;
	for (r=0; r<nrow; r++) {
		for (i=0; i<ncol; i++) {
			g=i-(limlow+1);
			if (i>limlow && i<limhigh) { // la fentre mobile est complte
				p=*windowlength;
				q=p/2;
				h=i-limlow; 			// Bordure minimale de la fentre mobile
				j=i+limlow;				// Bordure medimale de la fentre mobile	 
				if(lvec[r][g]<med[n-1] && lvec[r][j]<=med[n-1]){
					med[n]=med[n-1];		
				}else{
					if(lvec[r][g]>med[n-1] && lvec[r][j]>=med[n-1]){
					med[n]=med[n-1];		
					}else{
						l=0;
						for(k=h; k<=j; k++){
							lmed[l]=lvec[r][k];
							l=l+1;
						}
					  	qsort(lmed, p, sizeof(double), compare);
						med[n]=lmed[q];					
					}
				}
			} else {
				if (i<=limlow) {// Nous sommes au dbut de la srie
					h=0; 			// Bordure minimale de la fentre mobile
					j=i+limlow; 	// Bordure medimale de la fentre mobile
					p=j+1;
					q=p/2;
					Vecalloc(&lmed2, p);
					// DEBUT lA PROCEDURE
					l=0;
					for(k=h; k<=j; k++){
						lmed2[l]=lvec[r][k];
						l=l+1;
					}
				  	qsort(lmed2, p, sizeof(double), compare);
					med[n]=lmed2[q];
					free(lmed2);
					lmed2=NULL;
					
				} else { 	// Nous sommes  la fin de la srie
					h=i-limlow;	// Bordure minimale de la fentre mobile
					j=ncol-1;	// Bordure medimale de la fentre mobile
					p=j-h+1;
					q=p/2;
					Vecalloc(&lmed2, p);
					l=0;
					for(k=h; k<=j; k++){
						lmed2[l]=lvec[r][k];
						l=l+1;
					}
				  	qsort(lmed2, p, sizeof(double), compare);
					med[n]=lmed2[q];
					free(lmed2);
					lmed2=NULL;		
				}
			}
//		Rprintf("n = %d\th = %d\tj = %d\tp = %d\tq = %d\n",n,h,j,p,q);		
		n=n+1;
		}
    }
    free(lvec);
    lvec=NULL;
    free(lmed);
    lmed=NULL;
}

////////////////////////////////////////////////
void Rollmin(double *vec, int *windowlength, int *nr, int *nc, double *min){
	// Declarations de variables C locales
	double **lvec;
	int g,h,i,j,k,r,limlow,limhigh, nrow, ncol, n;
    nrow=*nr;
    ncol=*nc;
    // Allocation memoire pour les variables C locales
	Taballoc(&lvec, nrow, ncol);
	k = 0;
    for (i=0; i<nrow; i++) {
        for (j=0; j<ncol; j++) {
            lvec[i][j] = vec[k];
            k = k + 1;
        }
    }
   	limlow=(*windowlength-1)/2;
	limhigh=ncol-limlow;
	n=0;
	for (r=0; r<nrow; r++) {
		for (i=0; i<ncol; i++) {
			g=n-1;
			if (i>=limlow && i<limhigh) { 	// la fentre mobile est complte
				h=i-limlow; 			// Bordure minimale de la fentre mobile
				j=i+limlow;			// Bordure minimale de la fentre mobile	 
				if (lvec[r][j]<min[g]) {
					min[n]=lvec[r][j];
				} else {
					if (lvec[r][h-1]==min[g]) {
						min[n]=lvec[r][h];
						for (k = h; k <= j; k++) {
							if (lvec[r][k]<min[n]) { min[n]=lvec[r][k]; }
						}
					} else { min[n]=min[g];	}
				}
			} else {
				if (i<limlow) {			// Nous sommes au dbut de la srie
					h=0; 				// Bordure minimale de la fentre mobile
					j=i+limlow; 			// Bordure minimale de la fentre mobile
					if (i>0) {			// Initialisation  t faite
						if (lvec[r][j]<min[g]) { 
							min[n]=lvec[r][j];
						} else { min[n]=min[g]; }				
					
					} else {			// INITIAlISE lA PROCEDURE
						min[n]=lvec[r][i];
						for (k = h; k <= j; k++) {
							if (lvec[r][k]<min[n]) { min[n]=lvec[r][k]; }
						} 					
					}
				} else { 				// Nous sommes  la fin de la srie
					h=i-limlow;			// Bordure minimale de la fentre mobile
					j=ncol-1;	// Bordure minimale de la fentre mobile
					if (lvec[r][h-1]==min[g]) {
						min[n]=lvec[r][h];
						for (k = h; k <= j; k++) {
							if (lvec[r][k]<min[n]) { min[n]=lvec[r][k]; }
						} 
					} else { min[n]=min[g]; }			
				}
			}
		n=n+1;
		}
    }
    free(lvec);
    lvec=NULL;
}
////////////////////////////////////////////////

/***********************************************************************/
void Tabintalloc (int ***tab, int l1, int c1)
/*--------------------------------------------------
* Allocation de memoire dynamique pour un tableau
* d'entiers (l1, c1)
--------------------------------------------------*/
{
    int     i, j;
    
    *tab = (int **) calloc(l1+1, sizeof(int *));

    if ( *tab != NULL) {
        for (i=0;i<=l1;i++) {
            
            *(*tab+i)=(int *) calloc(c1+1, sizeof(int));        
            if ( *(*tab+i) == NULL ) {
                for (j=0;j<i;j++) {
                    free(*(*tab+j));
                    *(*tab+j)=NULL;
                }
                return;
            }
        }
    } else return;
    **(*tab) = l1;
    **(*tab+1) = c1;
    for (i=1;i<=l1;i++) {
        for (j=1;j<=c1;j++) {
            (*tab)[i][j] = 0;
        }
    }
}

/***********************************************************************/
void Taballoc (double ***tab, int l1, int c1)
/*--------------------------------------------------
* Allocation de memoire dynamique pour un tableau (l1, c1)
--------------------------------------------------*/
{
    /*int i, j;
    
    if ( (*tab = (double **) calloc(l1+1, sizeof(double *))) != 0) {
        for (i=0;i<=l1;i++) {
            if ( (*(*tab+i)=(double *) calloc(c1+1, sizeof(double))) == 0 ) {
                return;
                for (j=0;j<i;j++) {
                    free(*(*tab+j));
                    *(*tab+j)=NULL;
                }
            }
        }
    }else return;

    **(*tab) = l1;
    **(*tab+1) = c1;
    for (i=1;i<=l1;i++) {
        for (j=1;j<=c1;j++) {
            (*tab)[i][j] = 0;
        }
    }
    */
 	int     i, j;    
    *tab = (double **) calloc(l1+1, sizeof(double *));
    if ( *tab != NULL) {
        for (i=0;i<=l1;i++) {
            *(*tab+i)=(double *) calloc(c1+1, sizeof(double));        
            if ( *(*tab+i) == NULL ) {
                for (j=0;j<i;j++) {
                    free(*(*tab+j));
                    *(*tab+j)=NULL;
                }
                return;
            }
        }
    } else return;
    **(*tab) = l1;
    **(*tab+1) = c1;
    for (i=1;i<=l1;i++) {
        for (j=1;j<=c1;j++) {
            (*tab)[i][j] = 0;
        }
    }



}

/***********************************************************************/
void Vecalloc (double **vec, int n)
/*--------------------------------------------------
* Allocation de memoire pour un vecteur de longueur n
--------------------------------------------------*/
{
    if ( (*vec = (double *) calloc(n+1, sizeof(double))) != 0) {
        **vec = n;
        return;
    } else {
        return;
    }
}

/***********************************************************************/
void Vecintalloc (int **vec, int n)
/*--------------------------------------------------
* Allocation de memoire pour un vecteur d'entiers de longueur n
--------------------------------------------------*/
{
    if ( (*vec = (int *) calloc(n+1, sizeof(int))) != NULL) {
        **vec = n;
        return;
    } else {
        return;
    }
}

/***********************************************************************/
int compare (const void * a, const void * b)
{
  return ( *(int*)a - *(int*)b );
}
